#ifdef MAIN
#define EXPORT
#else
#define EXPORT extern
#endif

EXPORT uint8_t *gpr_pointer,*io_pointer,*sram_pointer,*eeprom_pointer;
EXPORT ListCommand *list_commands;
EXPORT int index_pins[MAX_CODE_PINS],/* for more fast searching of pin data  */
  index_ports[MAX_CODE_PORTS], /* for more fast searching of port data   */
  index_flags[MAX_CODE_FLAGS]; /* for more fast searching of flag data   */

EXPORT DrawArea drawarea;     /* here prints dissamblered code           */
EXPORT uint8_t temp_reg_t1;   /* TEMP register for accessing 16-bit reg. */
EXPORT uint8_t temp_reg_t3;   /* TEMP register for accessing 16-bit reg. */
EXPORT int stack_90s1200[3];  /* hardware stack of 90S1200               */

EXPORT Widget toplevel;
EXPORT Display *display;
EXPORT int scr_num;
EXPORT MemoryWindowDrawArea mwda;

/*used to detect changing byte of memory*/
EXPORT uint8_t *mem_file_changed,*eeprom_changed;
EXPORT int size_mem_file,size_eeprom;

#ifdef AVR_SIMULATOR
int pc=-1,                    /* pc register                             */
  num_call=0,                 /* number of inner calls                   */
  type_micro=0,               /* type of micro, default AT90S1200        */
  frequency=4000000,          /* frequency of MPU                        */
  debug=FALSE,                /* use for displaying current pixmap       */
  clocks=0,                   /* clocks                                  */
  load_memory,                /* flag for detecting type memory          */
  type_time=uS;

char error_message[80];
char *filename, *flags[]={"I:","T:","H:","S:","V:","N:","Z:","C:"};
#include "microcontrollers.h"
#include "commands.h"

#else
extern int type_micro,frequency,clocks,pc,debug,num_call;
extern Microcontroller controllers[];
extern Descr_io_port descr_io_ports[];
extern IO_port16 port16_wr[];
extern IO_port16 port16_rd[];
extern Command commands[];
#endif
